unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, jpeg, ExtCtrls, ComCtrls;

type TEntscheidungsfolge = array[1..81] of Record
        id:  integer;
        x:   integer;
        y:   integer;
        falsch: array[1..9] of integer;
      end;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    StartBtn: TBitBtn;
    LoeseBtnIti: TBitBtn;
    ResetBtn: TBitBtn;
    LoeseBtn: TButton;
    Label1: TLabel;
    Image1: TImage;
    StatusBar1: TStatusBar;
    procedure StartBtnClick(Sender: TObject);
    function Read(x,y:integer):string;
    procedure Write(x,y:integer;text:string);
    //function CheckZeile(var feld:sudokuFeld; Zeile,Wert:integer):boolean;
    function CheckZeile(Zeile,Wert:integer):boolean;
    function CheckSpalte(Spalte,Wert:integer):boolean;
    function CheckBlock(Spalte,Zeile,Wert:integer):boolean;
    procedure ResetBtnClick(Sender: TObject);
    function Check(Spalte,Zeile,Wert:integer):boolean;
    function komplett():boolean;
    procedure leer();
    procedure LoeseBtnClick(Sender: TObject);
    procedure loesen();
    procedure LoeseBtnItiClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function skomplett(nix:boolean):boolean;
    procedure allcheck();

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  //sudokuFeld:array[1..9] of array[1..9] of TPoint;
  freifeld:TPoint;
  falschZahl:array[1..9] of integer;
  efnummer:integer;
  checkstop:boolean;

implementation

{$R *.dfm}

procedure TForm1.allcheck();
var i,j:integer;
begin
  for i:=0 to 8 do begin
    for j:=0 to 8 do begin
    if (StrToIntDef(Read(i,j),0)= 0) and (Read(i,j)<>'') then
     begin
      showmessage('Falsche Eingabe in '+IntToStr(i)+' | '+IntToStr(j)+' !');
      checkstop:=true;
     end;
    end;
  end;
end;

procedure TForm1.loesen();
var Zeile, Spalte,Wert:integer;
begin
 leer();
 Spalte:=freifeld.X;
 Zeile:=freifeld.Y;
 if Zeile<>-1 then
 for Wert:=1 to 9 do
  if check(Spalte,Zeile,Wert)=true then
  begin
   Write(spalte,zeile,IntToStr(Wert));
   Application.ProcessMessages;
   Loesen();
  if komplett()=false then
   Write(spalte,zeile,'');
 end;
end;

procedure TForm1.leer();
var i,j,zeile,spalte:integer;
begin
  i:=0;
  spalte:=0;
  Zeile:=0;
  while i<9 do begin
    j:=0;
    while j<9 do begin
      if (Read(i,j)='') or (Read(i,j)=' ') then begin
        spalte:=i;
        zeile:=j;
        end;
      j:=j+1;
    end;
    i:=i+1;
  end;
  //if spalte=0 then begin asm int 3 end; end;
  freifeld.X:=spalte;
  freifeld.y:=zeile;
end;

function TForm1.CheckZeile(Zeile,Wert:integer):boolean;
var i:integer;
begin
  result:=true;
  i:=0;
  while i<9 do begin
   if StrToIntDef(Read(i,zeile),0)=wert then
    begin
      result:=false;
      exit;
    end;
    i:=i+1;
   end;
end;

function TForm1.CheckSpalte(Spalte,Wert:integer):boolean;
var i:integer;
begin
  result:=true;
  i:=0;
  while i<9 do begin
   if StrToIntDef(Read(spalte,i),0)=wert then
    begin
      result:=false;
      exit;
    end;
    i:=i+1;
   end;
end;

function TForm1.CheckBlock(Spalte,Zeile,Wert:integer):boolean;
var i,j:integer;
begin
  result:=true;
  i:=0;

  if (Spalte<3) and (Zeile<3) then begin Spalte:=0; Zeile:=0; end;                         //1
  if (Spalte>2) and (Spalte<6) and (Zeile<3) then begin Spalte:=3; Zeile:=0; end;          //2
  if (Spalte>5) and (Zeile<3) then begin Spalte:=6; Zeile:=0; end;                         //3
  if (Spalte<3) and (Zeile>2) and (Zeile<6) then begin Spalte:=0; Zeile:=3; end;           //2-1
  if (Spalte>2) and (Spalte<6) and (Zeile>2) and (Zeile<6) then begin Spalte:=3; Zeile:=3; end;           //2-2
  if (Spalte>5) and (Zeile>2) and (Zeile<6) then begin Spalte:=6; Zeile:=3; end;           //2-3
  if (Spalte<3) and (Zeile>5) then begin Spalte:=0; Zeile:=6; end;                         //3-1
  if (Spalte>2) and (Spalte<6) and (Zeile>5) then begin Spalte:=3; Zeile:=6; end;          //3-2
  if (Spalte>5) and (Zeile>5) then begin Spalte:=6; Zeile:=6; end;                         //3-3

  while i<3 do begin
   j:=0;
   while j<3 do begin
    if StrToIntDef(Read(Spalte+i, Zeile+j),0)=Wert then begin Result:=False; exit; end;
    j:=j+1;
   end;
   i:=i+1;
  end;
  end;

function TForm1.Check(Spalte,Zeile,Wert:integer):boolean;
begin
  result:=false;
   if (CheckSpalte(Spalte,Wert)=true)
   and (CheckZeile(Zeile,Wert)=true)
   and (CheckBlock(Spalte,Zeile,Wert)=true) then result:=true;
end;

function TForm1.komplett():boolean;
var i,j:integer;
begin
  result:=true;
  i:=0;
  while i<9 do begin
    j:=0;
    while j<9 do begin
     if StrToIntDef(Read(i,j),0)=0 then begin result:=false; exit; end;
     j:=j+1;
    end;
   i:=i+1;
   end;
end;

function TForm1.Read(x,y:integer):string;
begin
  result:=StringGrid1.Cells[x,y];
  
  //showmessage(result);
end;

procedure TForm1.Write(x,y:integer; text:string);
begin
  StringGrid1.Cells[x,y]:=text;
end;

procedure TForm1.StartBtnClick(Sender: TObject);
var i,j,x,y:Integer;
begin
   for i:=1 to 12 do
      begin
        randomize;
        sleep(1);
        j:=1+random(8);
        x:=random(9);
        y:=random(9);
        //showmessage(IntToStr(j)+' X'+IntToStr(x)+' Y'+IntToStr(y));
        if Check(x,y,j)=true then Write(x,y,IntToStr(j));
      end;

//StringGrid1.Cells[1,2]:='alpha';
end;

procedure TForm1.ResetBtnClick(Sender: TObject);
var i,j:integer;
begin
 i:=8;
 while i>-1 do begin
  j:=8;
  while j>-1 do begin
    Write(i,j,'');
    j:=j-1;
  end;
  i:=i-1;
 end;
end;

procedure TForm1.LoeseBtnClick(Sender: TObject);
var zeit:integer;
begin
zeit:=GetTickCount();
checkstop:=false;
allcheck();
if checkstop=false then
loesen();
zeit:=GetTickCount()-zeit;
Label1.Caption:=IntToStr(zeit)+' ms';
end;

procedure TForm1.LoeseBtnItiClick(Sender: TObject);
var i,r,k,f1,x,y,j:integer;
    ef:TEntscheidungsfolge;
    found:boolean;
begin
    i:=0;
    r:=0;
    k:=0;
     while i<1000 do begin
      found:=false;
      leer;
      x:= Freifeld.X;
      y:= Freifeld.Y;
      j:=1;
      while j<10 do begin
       if Check(x,y,j)=true then begin
        if j<>ef[efnummer].falsch[j] then begin
         Write(x,y,IntToStr(j));
         efnummer:=efnummer+1;
         ef[efnummer].Id:=j;
         ef[efnummer].X:=x;
         ef[efnummer].Y:=y;
         found:=true;
         break;
         end;
         end;
          while r<9 do begin
            if r=ef[efnummer].falsch[r] then k:=k+1;
            r:=r+1;
          end;
          if k>7 then
          begin
           efnummer:=efnummer-1;
           f1:=ef[efnummer].id;
           ef[efnummer].falsch[f1]:=f1;
           Write(ef[efnummer].x,ef[efnummer].y,'');
           showmessage('Done, master');
           found:=true;
          end;


       j:=j+1;
       end;
      if found=false then
      begin
        efnummer:=efnummer;
        ef[efnummer].falsch[j]:=j;
      end;
     i:=i+1;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
efnummer:=0;
end;

function TForm1.skomplett(nix:boolean):boolean;
var i,j:integer;
begin
 i:=0;
 result:=true;
  while i<9 do
    begin
     j:=0;
     while j<9 do
     begin
      if StrToIntDef(Read(i,j),0) = 0 then result:=false;
      end;
     end;


end;


end.
